'use strict';
var cashDetail = require('../services/cashDetailService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'addCashDetail': {
     return [
        body('unit', 'Unit is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');

exports.addCashDetail = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  cashDetail.addCashDetail(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.listCashDetails = function(req, res){
  cashDetail.listCashDetails(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getCashDetail = function(req, res){
  cashDetail.getCashDetail(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.updateCashDetail = function(req, res){
  cashDetail.updateCashDetail(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.deleteCashDetail = function(req, res){
  cashDetail.deleteCashDetail(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};