'use strict';
var employee = require('../services/employeeService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'add_employee': {
     return [
        body('name', 'Name is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');

exports.add_employee = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  employee.add_employee(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.employee_list = function(req, res){
  employee.employee_list(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.get_employee = function(req, res){
  employee.get_employee(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.update_employee = function(req, res){
  employee.update_employee(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.delete_employee = function(req, res){
  employee.delete_employee(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};