'use strict';
var paymentMethod = require('../services/paymentMethodService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'addPaymentMethod': {
     return [
        body('unit', 'Unit is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');

exports.addPaymentMethod = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  paymentMethod.addPaymentMethod(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.listPaymentMethods = function(req, res){
  paymentMethod.listPaymentMethods(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getPaymentMethod = function(req, res){
  paymentMethod.getPaymentMethod(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.updatePaymentMethod = function(req, res){
  paymentMethod.updatePaymentMethod(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.deletePaymentMethod = function(req, res){
  paymentMethod.deletePaymentMethod(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};