'use strict';
var staff = require('../services/staffService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'add_staff': {
     return [
        body('password', 'New password is required.').not().isEmpty(),
        body('staff_name', 'Name is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');

exports.add_staff = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  staff.add_staff(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.staff_list = function(req, res){
  staff.staff_list(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.update_staff = function(req, res){
  staff.update_staff(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.delete_staff = function(req, res){
  staff.delete_staff(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};