'user strict';
var sql = require('./../../conf/db.js');
var config = require('./../../conf/config.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var jwt = require('jsonwebtoken');
var fileUpload = require('express-fileupload'); 
var logsFile = require('./logsModel.js');
const saltRounds = 10;
var passwordHash;
var paymentType = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

//Add paymentType function
paymentType.addPaymentType = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("INSERT INTO payment_types (user_id,name,is_deleted,created_at,updated_at) VALUES ('"+body.user_id+"','"+body.name+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){
                    if(!errs){     
                        var logsData={added_by:body.user_id,type:'add_payment_type',message:'Payment Type ('+body.name+') has been added',json_data:JSON.stringify({id:res.insertId,type:'payment_type'})}  
                        logsFile.addLogs(authorization,logsData);
                        response = {
                            'status':'success',
                            'message':'Successfully inserted the payment type',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//paymentType list function
paymentType.listPaymentTypes = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var search='1 AND ';
                if(body.user_id)
                    search="user_id = '"+body.user_id+"' AND "
                if(body.name)
                    search+="name LIKE '%"+body.name.trim()+"%' AND "

                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }

                sql.query("SELECT * from payment_types WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully got all the payment types',
                            data:res,
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
            
        }); 
    });
} 

//Get paymentType function
paymentType.getPaymentType = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("SELECT * from payment_types WHERE id='"+id+"'",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'Payment type not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Update paymentType function
paymentType.updatePaymentType = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {            
            var createdDate = userDefinedFunction.databaseFormat();
            if(!err){
                sql.query("UPDATE payment_types SET name='"+body.name+"',updated_at='"+createdDate+"' WHERE id='"+body.id+"'",function(errs,res){
                    if(!errs){    
                        var logsData={added_by:body.user_id,type:'update_payment_type',message:'Payment Type ('+body.name+') has been updated',json_data:JSON.stringify({id:body.id,type:'payment_type'})}  
                        logsFile.addLogs(authorization,logsData);
                        response = {
                            'status':'success',
                            'message':'Successfully updated the payment type',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Delete paymentType function
paymentType.deletePaymentType = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            var today = new Date();
            var datetime = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate()+' '+today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
            if(!err){
                sql.query("UPDATE payment_types SET is_deleted='1' WHERE id='"+id+"'",function(errs,res){
                    if(!errs){     
                        sql.query("SELECT * from payment_types WHERE is_deleted=1 AND id='"+id+"'",function(errss,body){
                            var logsData={added_by:body[0].user_id,type:'delete_payment_type',message:'Payment Type ('+body[0].name+') has been deleted',json_data:JSON.stringify({id:body[0].id,type:'payment_type'})}  
                            logsFile.addLogs(authorization,logsData);
                        });   
                        response = {
                            'status':'success',
                            'message':'Successfully deleted the payment type',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= paymentType;